/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Timer.xs. Do not edit this file, edit Timer.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/POSIX/RT/Timer.xs"
/*
 * This software is copyright (c) 2010 by Leon Timmermans <leont@cpan.org>.
 *
 * This is free software; you can redistribute it and/or modify it under
 * the same terms as perl itself.
 *
 */

#define PERL_NO_GET_CONTEXT
#define PERL_REENTR_API 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_mg_findext
#include "ppport.h"

#include <signal.h>
#include <time.h>

#define die_sys(format) Perl_croak(aTHX_ format, strerror(errno))

typedef struct { const char* key; STRLEN key_length; clockid_t value; } map[];

static map clocks = {
	{ STR_WITH_LEN("realtime") , CLOCK_REALTIME  }
#ifdef CLOCK_REALTIME_COARSE
	, { STR_WITH_LEN("realtime_coarse"), CLOCK_REALTIME_COARSE }
#endif
#ifdef CLOCK_REALTIME_ALARM
	, { STR_WITH_LEN("realtime_alarm"), CLOCK_REALTIME_ALARM }
#endif
#ifdef CLOCK_MONOTONIC
	, { STR_WITH_LEN("monotonic"), CLOCK_MONOTONIC }
#elif defined CLOCK_HIGHRES
	, { STR_WITH_LEN("monotonic"), CLOCK_HIGHRES }
#endif
#ifdef CLOCK_MONOTONIC_RAW
	, { STR_WITH_LEN("monotonic_raw"), CLOCK_MONOTONIC_RAW }
#endif
#ifdef CLOCK_MONOTONIC_COARSE
	, { STR_WITH_LEN("monotonic_coarse"), CLOCK_MONOTONIC_COARSE }
#endif
#ifdef CLOCK_PROCESS_CPUTIME_ID
	, { STR_WITH_LEN("process"), CLOCK_PROCESS_CPUTIME_ID }
#elif defined CLOCK_PROF
	, { STR_WITH_LEN("process"), CLOCK_PROF }
#endif
#ifdef CLOCK_THREAD_CPUTIME_ID
	, { STR_WITH_LEN("thread"), CLOCK_THREAD_CPUTIME_ID }
#endif
#ifdef CLOCK_UPTIME
	, { STR_WITH_LEN("uptime"), CLOCK_UPTIME }
#endif
#ifdef CLOCK_BOOTTIME
	, { STR_WITH_LEN("boottime"), CLOCK_BOOTTIME }
#endif
#ifdef CLOCK_BOOTTIME_ALARM
	, { STR_WITH_LEN("boottime_alarm"), CLOCK_BOOTTIME_ALARM }
#endif
#ifdef CLOCK_VIRTUAL
	, { STR_WITH_LEN("virtual"), CLOCK_VIRTUAL }
#endif
#ifdef CLOCK_TAI
	, { STR_WITH_LEN("tai"), CLOCK_TAI }
#endif
};

static clockid_t S_get_clockid(pTHX_ SV* clock_name) {
	int i;
	STRLEN length;
	const char* clock_ptr = SvPV(clock_name, length);
	for (i = 0; i < sizeof clocks / sizeof *clocks; ++i) {
		if (clocks[i].key_length == length && strEQ(clock_ptr, clocks[i].key))
			return clocks[i].value;
	}
	Perl_croak(aTHX_ "No such timer '%s' known", clock_name);
}
#define get_clockid(name) S_get_clockid(aTHX_ name)

#define NANO_SECONDS 1000000000

static NV timespec_to_nv(struct timespec* time) {
	return time->tv_sec + time->tv_nsec / (double)NANO_SECONDS;
}

static void nv_to_timespec(NV input, struct timespec* output) {
	output->tv_sec  = (time_t) floor(input);
	output->tv_nsec = (long) ((input - output->tv_sec) * NANO_SECONDS);
}

static int timer_destroy(pTHX_ SV* var, MAGIC* magic) {
	if (timer_delete(*(timer_t*)magic->mg_ptr))
		die_sys("Can't delete timer: %s");
}

static const MGVTBL timer_magic = { NULL, NULL, NULL, NULL, timer_destroy };

static MAGIC* S_get_magic(pTHX_ SV* ref, const char* funcname, const MGVTBL* vtbl) {
	SV* value;
	MAGIC* magic;
	if (!SvROK(ref) || !(value = SvRV(ref)) || !SvMAGICAL(value) || (magic = mg_findext(value, PERL_MAGIC_ext, vtbl)) == NULL)
		Perl_croak(aTHX_ "Could not %s: this variable is not a timer", funcname);
	return magic;
}
#define get_magic(ref, funcname, vtbl) S_get_magic(aTHX_ ref, funcname, vtbl)
#define get_timer(ref, funcname) (*(timer_t*)get_magic(ref, funcname, &timer_magic)->mg_ptr)

static clockid_t S_get_clock(pTHX_ SV* ref, const char* funcname) {
	SV* value;
	if (!SvROK(ref) || !(value = SvRV(ref)))
		Perl_croak(aTHX_ "Could not %s: this variable is not a clock", funcname);
	return SvUV(value);
}
#define get_clock(ref, func) S_get_clock(aTHX_ ref, func)

#if defined(SIGEV_THREAD_ID) && defined(SYS_gettid)
#include <sys/syscall.h>
#define gettid() syscall(SYS_gettid)
#ifndef sigev_notify_thread_id
#define sigev_notify_thread_id   _sigev_un._tid
#endif
#endif

static SV* S_create_clock(pTHX_ clockid_t clockid, SV* class) {
	SV *tmp, *retval;
	tmp = newSViv(clockid);
	retval = newRV_noinc(tmp);
	sv_bless(retval, gv_stashsv(class, 0));
	SvREADONLY_on(tmp);
	return retval;
}
#define create_clock(clockid, class) S_create_clock(aTHX_ clockid, class)

#if defined(_POSIX_CLOCK_SELECTION) && _POSIX_CLOCK_SELECTION >= 0
static int my_clock_nanosleep(pTHX_ clockid_t clockid, int flags, const struct timespec* request, struct timespec* remain) {
	int ret;
	ret = clock_nanosleep(clockid, flags, request, remain);
	if (ret != 0) {
		errno = ret;
		if (ret != EINTR)
			die_sys("Could not sleep: %s");
	}
	return ret;
}
#endif

#define clock_nanosleep(clockid, flags, request, remain) my_clock_nanosleep(aTHX_ clockid, flags, request, remain)

#if defined(USE_ITHREADS) && defined(_POSIX_THREAD_CPUTIME) && _POSIX_THREAD_CPUTIME >= 0
static pthread_t* S_get_pthread(pTHX_ SV* thread_handle) {
	SV* tmp;
	pthread_t* ret;
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	PUSHs(thread_handle);
	PUTBACK;
	call_method("_handle", G_SCALAR);
	SPAGAIN;
	tmp = POPs;
	ret = INT2PTR(pthread_t* ,SvUV(tmp));
	FREETMPS;
	LEAVE;
	return ret;
}
#define get_pthread(handle) S_get_pthread(aTHX_ handle)
#endif

#define undef &PL_sv_undef

typedef struct _timer_init {
	clockid_t clockid;
	IV signo;
	IV ident;
	struct itimerspec itimer;
	int flags;
} timer_init;

static void S_timer_args(pTHX_ timer_init* para, SV** begin, Size_t items) {
	int i;
	for(i = 0; i < items; i += 2) {
		const char* current;
		STRLEN curlen;
		SV *key = begin[i], *value = begin[i+1];
		current = SvPV(key, curlen);
		if (curlen == 5) {
			if (strEQ(current, "clock"))
				para->clockid = SvROK(value) ? get_clock(value, "create timer") : get_clockid(value);
			else if (strEQ(current, "value"))
				nv_to_timespec(SvNV(value), &para->itimer.it_value);
			else if (strEQ(current, "ident"))
				para->ident = SvIV(value);
			else
				goto fail;
		}
		else if (curlen == 6 && strEQ(current, "signal"))
			para->signo = (SvIOK(value) || looks_like_number(value)) ? SvIV(value) : whichsig(SvPV_nolen(value));
		else if (curlen == 8) {
			if (strEQ(current, "interval"))
				nv_to_timespec(SvNV(value), &para->itimer.it_interval);
			else if (strEQ(current, "absolute"))
				para->flags |= TIMER_ABSTIME;
			else
				goto fail;
		}
		else
			fail: Perl_croak(aTHX_ "Unknown option '%s'", current);
	}
}
#define timer_args(para, begin, items) S_timer_args(aTHX_ para, begin, items)

static SV* S_timer_instantiate(pTHX_ timer_init* para, const char* class, Size_t classlength) {
	timer_t* timer;
	struct sigevent event = { 0 };
	SV *tmp, *retval;
	MAGIC* mg;

	if (para->signo < 0)
		Perl_croak(aTHX_ "No valid signal was given");

#ifdef gettid
	event.sigev_notify           = SIGEV_THREAD_ID;
	event.sigev_notify_thread_id = gettid();
#else
	event.sigev_notify           = SIGEV_SIGNAL;
#endif
	event.sigev_signo            = para->signo;
	event.sigev_value.sival_int  = para->ident;

	Newx(timer, 1, timer_t);

	if (timer_create(para->clockid, &event, timer) < 0) {
		Safefree(timer);
		die_sys("Couldn't create timer: %s");
	}
	if (timer_settime(*timer, para->flags, &para->itimer, NULL) < 0)
		die_sys("Couldn't set_time: %s");

	tmp = newSV(0);
	retval = sv_2mortal(sv_bless(newRV_noinc(tmp), gv_stashpvn(class, classlength, 0)));
	SvREADONLY_on(tmp);

	mg = sv_magicext(tmp, NULL, PERL_MAGIC_ext, &timer_magic, (const char*)timer, 0);
	mg->mg_len = sizeof *timer;
	return retval;
}
#define timer_instantiate(para, class, classlen) S_timer_instantiate(aTHX_ para, class, classlen)

#line 261 "lib/POSIX/RT/Timer.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 405 "lib/POSIX/RT/Timer.c"

XS_EUPXS(XS_POSIX__RT__Timer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	class = ST(0)
;
#line 258 "lib/POSIX/RT/Timer.xs"
		const char* class_str;
		Size_t length;
#line 421 "lib/POSIX/RT/Timer.c"
#line 261 "lib/POSIX/RT/Timer.xs"
		class_str = SvPV(class, length);
		timer_init para = { CLOCK_REALTIME, 0, 0, 0, 0};
		timer_args(&para, SP + 2, items - 1);
		PUSHs(timer_instantiate(&para, class_str, length));
#line 427 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Timer_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
	UV	RETVAL;
	dXSTARG;
#line 270 "lib/POSIX/RT/Timer.xs"
		RETVAL = (UV)get_timer(self, "id");
#line 447 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Timer_get_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_get_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 278 "lib/POSIX/RT/Timer.xs"
		timer_t timer;
		struct itimerspec value;
#line 469 "lib/POSIX/RT/Timer.c"
#line 281 "lib/POSIX/RT/Timer.xs"
		timer = get_timer(self, "get_timeout");
		if (timer_gettime(timer, &value) == -1)
			die_sys("Couldn't get_time: %s");
		mXPUSHn(timespec_to_nv(&value.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&value.it_interval));
#line 477 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Timer_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "self, new_value, new_interval = 0, abstime = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
	NV	new_value = (NV)SvNV(ST(1))
;
	NV	new_interval;
	IV	abstime;
#line 295 "lib/POSIX/RT/Timer.xs"
		timer_t timer;
		struct itimerspec new_itimer, old_itimer;
#line 502 "lib/POSIX/RT/Timer.c"

	if (items < 3)
	    new_interval = 0;
	else {
	    new_interval = (NV)SvNV(ST(2))
;
	}

	if (items < 4)
	    abstime = 0;
	else {
	    abstime = (IV)SvIV(ST(3))
;
	}
#line 298 "lib/POSIX/RT/Timer.xs"
		timer = get_timer(self, "set_timeout");
		nv_to_timespec(new_value, &new_itimer.it_value);
		nv_to_timespec(new_interval, &new_itimer.it_interval);
		if (timer_settime(timer, (abstime ? TIMER_ABSTIME : 0), &new_itimer, &old_itimer) == -1)
			die_sys("Couldn't set_time: %s");
		mXPUSHn(timespec_to_nv(&old_itimer.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&old_itimer.it_interval));
#line 526 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Timer_get_overrun); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_get_overrun)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 311 "lib/POSIX/RT/Timer.xs"
		timer_t timer;
#line 544 "lib/POSIX/RT/Timer.c"
	IV	RETVAL;
	dXSTARG;
#line 313 "lib/POSIX/RT/Timer.xs"
		timer = get_timer(self, "get_overrun");
		RETVAL = timer_getoverrun(timer);
		if (RETVAL == -1) 
			die_sys("Couldn't get_overrun: %s");
#line 552 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    {
	SV*	class = ST(0)
;
#line 328 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
#line 571 "lib/POSIX/RT/Timer.c"
	SV *	RETVAL;
#line 330 "lib/POSIX/RT/Timer.xs"
		clockid = items > 1 ? get_clockid(ST(1)) : CLOCK_REALTIME;
		RETVAL = create_clock(clockid, class);
#line 576 "lib/POSIX/RT/Timer.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
	UV	RETVAL;
	dXSTARG;
#line 339 "lib/POSIX/RT/Timer.xs"
		RETVAL = (UV)get_clock(self, "id");
#line 597 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#if defined(_POSIX_CPUTIME) && _POSIX_CPUTIME >= 0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_POSIX__RT__Clock_get_cpuclock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_cpuclock)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, pid = undef");
    {
	SV*	class = ST(0)
;
	SV*	pid;
#line 349 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
#line 620 "lib/POSIX/RT/Timer.c"
	SV *	RETVAL;

	if (items < 2)
	    pid = undef;
	else {
	    pid = ST(1)
;
	}
#line 351 "lib/POSIX/RT/Timer.xs"
		if (SvOK(pid) && SvROK(pid) && sv_derived_from(pid, "threads")) {
#if defined(USE_ITHREADS) && defined(_POSIX_THREAD_CPUTIME) && _POSIX_THREAD_CPUTIME >= 0
			pthread_t* handle = get_pthread(pid);
			if (pthread_getcpuclockid(*handle, &clockid) != 0)
				die_sys("Could not get cpuclock");
#else
			Perl_croak(aTHX_ "Can't get CPU time for threads");
#endif
		}
		else {
			if (clock_getcpuclockid(SvOK(pid) ? SvIV(pid) : 0, &clockid) != 0)
				die_sys("Could not get cpuclock");
		}

		RETVAL = create_clock(clockid, class);
#line 645 "lib/POSIX/RT/Timer.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_POSIX__RT__Clock_get_clocks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_clocks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	class = ST(0)
;
#line 375 "lib/POSIX/RT/Timer.xs"
		size_t i;
		const size_t max = sizeof clocks / sizeof *clocks;
#line 668 "lib/POSIX/RT/Timer.c"
#line 378 "lib/POSIX/RT/Timer.xs"
		for (i = 0; i < max; ++i)
			mXPUSHp(clocks[i].key, clocks[i].key_length);
		XSRETURN(max);
#line 673 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Clock_get_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 386 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
		struct timespec time;
#line 692 "lib/POSIX/RT/Timer.c"
	NV	RETVAL;
	dXSTARG;
#line 389 "lib/POSIX/RT/Timer.xs"
		clockid = get_clock(self, "get_time");
		if (clock_gettime(clockid, &time) == -1)
			die_sys("Couldn't get time: %s");
		RETVAL = timespec_to_nv(&time);
#line 700 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_set_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_set_time)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, frac_time");
    {
	SV*	self = ST(0)
;
	NV	frac_time = (NV)SvNV(ST(1))
;
#line 401 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
		struct timespec time;
#line 722 "lib/POSIX/RT/Timer.c"
#line 404 "lib/POSIX/RT/Timer.xs"
		clockid = get_clock(self, "set_time");
		nv_to_timespec(frac_time, &time);
		if (clock_settime(clockid, &time) == -1)
			die_sys("Couldn't set time: %s");
#line 728 "lib/POSIX/RT/Timer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__RT__Clock_get_resolution); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_resolution)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 413 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
		struct timespec time;
#line 746 "lib/POSIX/RT/Timer.c"
	NV	RETVAL;
	dXSTARG;
#line 416 "lib/POSIX/RT/Timer.xs"
		clockid = get_clock(self, "get_resolution");
		if (clock_getres(clockid, &time) == -1)
			die_sys("Couldn't get resolution: %s");
		RETVAL = timespec_to_nv(&time);
#line 754 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_timer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_timer)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 427 "lib/POSIX/RT/Timer.xs"
		timer_init para = { CLOCK_REALTIME, 0, 0, 0, 0};
		timer_args(&para, SP + 2, items - 1);
		para.clockid = get_clock(self, "timer");
		PUSHs(timer_instantiate(&para, "POSIX::RT::Timer", 16));
#line 778 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}

#if defined(_POSIX_CLOCK_SELECTION) && _POSIX_CLOCK_SELECTION >= 0
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_POSIX__RT__Clock_sleep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_sleep)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, frac_time, abstime = 0");
    {
	SV*	self = ST(0)
;
	NV	frac_time = (NV)SvNV(ST(1))
;
	int	abstime;
#line 439 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
		struct timespec sleep_time, remain_time;
		int flags;
#line 804 "lib/POSIX/RT/Timer.c"
	NV	RETVAL;
	dXSTARG;

	if (items < 3)
	    abstime = 0;
	else {
	    abstime = (int)SvIV(ST(2))
;
	}
#line 443 "lib/POSIX/RT/Timer.xs"
		clockid = get_clock(self, "sleep");
		flags = abstime ? TIMER_ABSTIME : 0;
		nv_to_timespec(frac_time, &sleep_time);

		if (clock_nanosleep(clockid, flags, &sleep_time, &remain_time) == EINTR)
			RETVAL = abstime ? frac_time : timespec_to_nv(&remain_time);
		else 
			RETVAL = 0;
#line 823 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_sleep_deeply); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_sleep_deeply)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, frac_time, abstime = 0");
    {
	SV*	self = ST(0)
;
	NV	frac_time = (NV)SvNV(ST(1))
;
	int	abstime;
#line 460 "lib/POSIX/RT/Timer.xs"
		clockid_t clockid;
		struct timespec sleep_time;
		NV real_time;
#line 847 "lib/POSIX/RT/Timer.c"
	NV	RETVAL;
	dXSTARG;

	if (items < 3)
	    abstime = 0;
	else {
	    abstime = (int)SvIV(ST(2))
;
	}
#line 464 "lib/POSIX/RT/Timer.xs"
		clockid = get_clock(self, "sleep_deeply");
		if (abstime)
			nv_to_timespec(frac_time, &sleep_time);
		else {
			if (clock_gettime(clockid, &sleep_time) == -1)
				die_sys("Couldn't get time: %s");
			nv_to_timespec(timespec_to_nv(&sleep_time) + frac_time, &sleep_time);
		}
		while (clock_nanosleep(clockid, TIMER_ABSTIME, &sleep_time, NULL) == EINTR);
		RETVAL = 0;
#line 868 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_POSIX__RT__Timer); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_POSIX__RT__Timer)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("POSIX::RT::Timer::new", XS_POSIX__RT__Timer_new);
        newXS_deffile("POSIX::RT::Timer::handle", XS_POSIX__RT__Timer_handle);
        newXS_deffile("POSIX::RT::Timer::get_timeout", XS_POSIX__RT__Timer_get_timeout);
        newXS_deffile("POSIX::RT::Timer::set_timeout", XS_POSIX__RT__Timer_set_timeout);
        newXS_deffile("POSIX::RT::Timer::get_overrun", XS_POSIX__RT__Timer_get_overrun);
        newXS_deffile("POSIX::RT::Clock::new", XS_POSIX__RT__Clock_new);
        newXS_deffile("POSIX::RT::Clock::handle", XS_POSIX__RT__Clock_handle);
#if XSubPPtmpAAAA
        newXS_deffile("POSIX::RT::Clock::get_cpuclock", XS_POSIX__RT__Clock_get_cpuclock);
#endif
        newXS_deffile("POSIX::RT::Clock::get_clocks", XS_POSIX__RT__Clock_get_clocks);
        newXS_deffile("POSIX::RT::Clock::get_time", XS_POSIX__RT__Clock_get_time);
        newXS_deffile("POSIX::RT::Clock::set_time", XS_POSIX__RT__Clock_set_time);
        newXS_deffile("POSIX::RT::Clock::get_resolution", XS_POSIX__RT__Clock_get_resolution);
        newXS_deffile("POSIX::RT::Clock::timer", XS_POSIX__RT__Clock_timer);
#if XSubPPtmpAAAB
        newXS_deffile("POSIX::RT::Clock::sleep", XS_POSIX__RT__Clock_sleep);
        newXS_deffile("POSIX::RT::Clock::sleep_deeply", XS_POSIX__RT__Clock_sleep_deeply);
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 930 "lib/POSIX/RT/Timer.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
